import{_ as i}from"./arthas-web-ui.89f4fc6d.js";import{_ as c,o as l,c as u,a as s,b as a,w as r,e as n,d as t,r as o}from"./app.98a29f3d.js";const d={},m=s("h1",{id:"http-api",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#http-api","aria-hidden":"true"},"#"),n(" Http API")],-1),v={href:"https://arthas.aliyun.com/doc/arthas-tutorials.html?language=en&id=case-http-api",target:"_blank",rel:"noopener noreferrer"},k=s("code",null,"Http API",-1),b=n(" online tutorial"),h=t(`<h2 id="overview" tabindex="-1"><a class="header-anchor" href="#overview" aria-hidden="true">#</a> Overview</h2><p>Http API provides a RESTful-like interactive interface, and both requests and responses data in JSON format. Compared with Telnet/WebConsole&#39;s output unstructured text data, Http API can provide structured data and support more complex interactive functions, such as a series of diagnostic operations in specific application scenarios.</p><h3 id="access-address" tabindex="-1"><a class="header-anchor" href="#access-address" aria-hidden="true">#</a> Access address</h3><p>The Http API address is: <code>http://ip:port/api</code>, the request parameters must be submitted using <code>POST</code>. Such as POST <code>http://127.0.0.1:8563/api</code>.</p><p>Note: The telnet port <code>3658</code> has compatibility issues with the Chrome browser. It is recommended to use the http port <code>8563</code> to access the http api.</p><h3 id="request-data-format" tabindex="-1"><a class="header-anchor" href="#request-data-format" aria-hidden="true">#</a> Request data format</h3><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">{</span>
  <span class="token property">&quot;action&quot;</span><span class="token operator">:</span> <span class="token string">&quot;exec&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;requestId&quot;</span><span class="token operator">:</span> <span class="token string">&quot;req112&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;sessionId&quot;</span><span class="token operator">:</span> <span class="token string">&quot;94766d3c-8b39-42d3-8596-98aee3ccbefb&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;consumerId&quot;</span><span class="token operator">:</span> <span class="token string">&quot;955dbd1325334a84972b0f3ac19de4f7_2&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;command&quot;</span><span class="token operator">:</span> <span class="token string">&quot;version&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;execTimeout&quot;</span><span class="token operator">:</span> <span class="token string">&quot;10000&quot;</span>
<span class="token punctuation">}</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p>Request data format description:</p><ul><li><code>action</code> : The requested action/behavior, please refer to &quot;Request Actions&quot; for optional values.</li><li><code>requestId</code> : Optional request ID, generated by the client.</li><li><code>sessionId</code> : Arthas session ID, one-time command does not need to set the session ID.</li><li><code>consumerId</code> : Arthas consumer ID, used for multi-person sharing sessions.</li><li><code>command</code> : Arthas command line</li><li><code>execTimeout</code> : Timeout for executing commands (ms), default value is 30000.</li></ul><p>Note: Different actions use different parameters. Set the parameters according to the specific action.</p><h3 id="request-actions" tabindex="-1"><a class="header-anchor" href="#request-actions" aria-hidden="true">#</a> Request Actions</h3><p>Currently supported request actions are as follows:</p><ul><li><code>exec</code> : The command is executed synchronously, and the command results is returned after the command execution end or interrupted.</li><li><code>async_exec</code> : The command is executed asynchronously, and the scheduling result of the command is returned immediately. The command execution result is obtained through <code>pull_results</code> action.</li><li><code>interrupt_job</code> : To interrupt the foreground command of the session, similar to the function of Telnet <code>Ctrl + c</code>.</li><li><code>pull_results</code> : Get the result of the command executed asynchronously, and execute it repeatedly in http long-polling mode.</li><li><code>init_session</code> : Create new session.</li><li><code>join_session</code> : Join the session, used to support multiple people sharing the same Arthas session.</li><li><code>close_session</code> : Close the session.</li></ul><h3 id="response-status" tabindex="-1"><a class="header-anchor" href="#response-status" aria-hidden="true">#</a> Response status</h3><p>The state attribute in the response indicates the request processing state, and its value is as follows:</p><ul><li><code>SCHEDULED</code>: When the command is executed asynchronously, it means that the job has been created, and may not be executed yet or is being executed;</li><li><code>SUCCEEDED</code>: The request is processed successfully (completed status);</li><li><code>FAILED</code>: Request processing failed (completed status), usually accompanied by a message explaining the reason;</li><li><code>REFUSED</code>: The request is rejected (completed status), usually accompanied by a message explaining the reason;</li></ul><h2 id="one-time-command" tabindex="-1"><a class="header-anchor" href="#one-time-command" aria-hidden="true">#</a> One-time command</h2><p>Similar to executing batch commands, the one-time commands are executed synchronously. No need to create a session, no need to set the <code>sessionId</code> option.</p><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">{</span>
  <span class="token property">&quot;action&quot;</span><span class="token operator">:</span> <span class="token string">&quot;exec&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;command&quot;</span><span class="token operator">:</span> <span class="token string">&quot;&lt;Arthas command line&gt;&quot;</span>
<span class="token punctuation">}</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p>For example, get the Arthas version number:</p><div class="language-bash ext-sh line-numbers-mode"><pre class="language-bash"><code><span class="token function">curl</span> <span class="token parameter variable">-Ss</span> <span class="token parameter variable">-XPOST</span> http://localhost:8563/api <span class="token parameter variable">-d</span> <span class="token string">&#39;
{
  &quot;action&quot;:&quot;exec&quot;,
  &quot;command&quot;:&quot;version&quot;
}
&#39;</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p>The response is as follows:</p><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">{</span>
  <span class="token property">&quot;state&quot;</span><span class="token operator">:</span> <span class="token string">&quot;SUCCEEDED&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;sessionId&quot;</span><span class="token operator">:</span> <span class="token string">&quot;ee3bc004-4586-43de-bac0-b69d6db7a869&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;body&quot;</span><span class="token operator">:</span> <span class="token punctuation">{</span>
    <span class="token property">&quot;results&quot;</span><span class="token operator">:</span> <span class="token punctuation">[</span>
      <span class="token punctuation">{</span>
        <span class="token property">&quot;type&quot;</span><span class="token operator">:</span> <span class="token string">&quot;version&quot;</span><span class="token punctuation">,</span>
        <span class="token property">&quot;version&quot;</span><span class="token operator">:</span> <span class="token string">&quot;3.3.7&quot;</span><span class="token punctuation">,</span>
        <span class="token property">&quot;jobId&quot;</span><span class="token operator">:</span> <span class="token number">5</span>
      <span class="token punctuation">}</span><span class="token punctuation">,</span>
      <span class="token punctuation">{</span>
        <span class="token property">&quot;jobId&quot;</span><span class="token operator">:</span> <span class="token number">5</span><span class="token punctuation">,</span>
        <span class="token property">&quot;statusCode&quot;</span><span class="token operator">:</span> <span class="token number">0</span><span class="token punctuation">,</span>
        <span class="token property">&quot;type&quot;</span><span class="token operator">:</span> <span class="token string">&quot;status&quot;</span>
      <span class="token punctuation">}</span>
    <span class="token punctuation">]</span><span class="token punctuation">,</span>
    <span class="token property">&quot;timeExpired&quot;</span><span class="token operator">:</span> <span class="token boolean">false</span><span class="token punctuation">,</span>
    <span class="token property">&quot;command&quot;</span><span class="token operator">:</span> <span class="token string">&quot;version&quot;</span><span class="token punctuation">,</span>
    <span class="token property">&quot;jobStatus&quot;</span><span class="token operator">:</span> <span class="token string">&quot;TERMINATED&quot;</span><span class="token punctuation">,</span>
    <span class="token property">&quot;jobId&quot;</span><span class="token operator">:</span> <span class="token number">5</span>
  <span class="token punctuation">}</span>
<span class="token punctuation">}</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p>Response data format description:</p><ul><li><code>state</code>: Request processing status, refer to the description of &quot;Response Status&quot;.</li><li><code>sessionId </code>: Arthas session ID, one-time command to automatically create and destroy temporary sessions.</li><li><code>body.jobId</code>: The job ID of the command, all output results of the same job are the same jobId.</li><li><code>body.jobStatus</code>: The job status of the command.</li><li><code>body.timeExpired</code>: Whether the job execution timed out.</li><li><code>body/results</code>: Command execution results.</li></ul><p><strong>Command result format description</strong></p><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">[</span>
  <span class="token punctuation">{</span>
    <span class="token property">&quot;type&quot;</span><span class="token operator">:</span> <span class="token string">&quot;version&quot;</span><span class="token punctuation">,</span>
    <span class="token property">&quot;version&quot;</span><span class="token operator">:</span> <span class="token string">&quot;3.3.7&quot;</span><span class="token punctuation">,</span>
    <span class="token property">&quot;jobId&quot;</span><span class="token operator">:</span> <span class="token number">5</span>
  <span class="token punctuation">}</span><span class="token punctuation">,</span>
  <span class="token punctuation">{</span>
    <span class="token property">&quot;jobId&quot;</span><span class="token operator">:</span> <span class="token number">5</span><span class="token punctuation">,</span>
    <span class="token property">&quot;statusCode&quot;</span><span class="token operator">:</span> <span class="token number">0</span><span class="token punctuation">,</span>
    <span class="token property">&quot;type&quot;</span><span class="token operator">:</span> <span class="token string">&quot;status&quot;</span>
  <span class="token punctuation">}</span>
<span class="token punctuation">]</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><ul><li><code>type</code> : The command result type, except for the special ones such as <code>status</code>, the others remain the same as the Arthas command name. Please refer to the section &quot;<a href="#special_command_results">Special command results</a>&quot;.</li><li><code>jobId</code> : The job ID of the command.</li><li>Other fields are the data of each different command.</li></ul><p>Note: You can also use a one-time command to execute continuous output commands such as watch/trace, but you can&#39;t interrupt the command execution, and there may be hang up for a long time. Please refer to the example in the &quot;<a href="#change_watch_value_to_map">Make watch command output a map object</a>&quot; section.</p><p>Please try to deal with it in the following way:</p><ul><li>Set a reasonable <code>execTimeout</code> to forcibly interrupt the command execution after the timeout period is reached to avoid a long hang.</li><li>Use the <code>-n</code> parameter to specify a smaller number of executions.</li><li>Ensure the methods of the command matched can be successfully hit and the <code>condition-express</code> is written correctly. If the <code>watch/trace</code> does not hit, even if <code>-n 1</code> is specified, it will hang and wait until the execution timeout.</li></ul><h2 id="session-interaction" tabindex="-1"><a class="header-anchor" href="#session-interaction" aria-hidden="true">#</a> Session interaction</h2><p>Users create and manage Arthas sessions, which are suitable for complex interactive processes. The access process is as follows:</p><ul><li>Create a session</li><li>Join the session (optional)</li><li>Pull command results</li><li>Execute a series of commands</li><li>Interrupt command execution</li><li>Close the session</li></ul><h3 id="create-session" tabindex="-1"><a class="header-anchor" href="#create-session" aria-hidden="true">#</a> Create session</h3><div class="language-bash ext-sh line-numbers-mode"><pre class="language-bash"><code><span class="token function">curl</span> <span class="token parameter variable">-Ss</span> <span class="token parameter variable">-XPOST</span> http://localhost:8563/api <span class="token parameter variable">-d</span> <span class="token string">&#39;
{
  &quot;action&quot;:&quot;init_session&quot;
}
&#39;</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p>Response result:</p><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">{</span>
  <span class="token property">&quot;sessionId&quot;</span><span class="token operator">:</span> <span class="token string">&quot;b09f1353-202c-407b-af24-701b744f971e&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;consumerId&quot;</span><span class="token operator">:</span> <span class="token string">&quot;5ae4e5fbab8b4e529ac404f260d4e2d1_1&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;state&quot;</span><span class="token operator">:</span> <span class="token string">&quot;SUCCEEDED&quot;</span>
<span class="token punctuation">}</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p>The new session ID is: <code>b09f1353-202c-407b-af24-701b744f971e</code>, and consumer ID is: <code>5ae4e5fbab8b4e529ac404f260d4e2d1_1</code>.</p><h3 id="join-session" tabindex="-1"><a class="header-anchor" href="#join-session" aria-hidden="true">#</a> Join session</h3><p>Specify the session ID to join, and the server will assign a new consumer ID. Multiple consumers can receive the same command results of target session. This interface is used to support multiple people sharing the same session or refreshing the page to retrieve the session history.</p><div class="language-bash ext-sh line-numbers-mode"><pre class="language-bash"><code><span class="token function">curl</span> <span class="token parameter variable">-Ss</span> <span class="token parameter variable">-XPOST</span> http://localhost:8563/api <span class="token parameter variable">-d</span> <span class="token string">&#39;
{
  &quot;action&quot;:&quot;join_session&quot;,
  &quot;sessionId&quot; : &quot;b09f1353-202c-407b-af24-701b744f971e&quot;
}
&#39;</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p>Response result:</p><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">{</span>
  <span class="token property">&quot;consumerId&quot;</span><span class="token operator">:</span> <span class="token string">&quot;8f7f6ad7bc2d4cb5aa57a530927a95cc_2&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;sessionId&quot;</span><span class="token operator">:</span> <span class="token string">&quot;b09f1353-202c-407b-af24-701b744f971e&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;state&quot;</span><span class="token operator">:</span> <span class="token string">&quot;SUCCEEDED&quot;</span>
<span class="token punctuation">}</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p>The new consumer ID is <code>8f7f6ad7bc2d4cb5aa57a530927a95cc_2 </code> .</p><h3 id="pull-command-results" tabindex="-1"><a class="header-anchor" href="#pull-command-results" aria-hidden="true">#</a> Pull command results</h3><p>The action of pulling the command result message is <code>pull_results</code>. Please use the Http long-polling method to periodically pull the result messages. The consumer&#39;s timeout period is 5 minutes. After the timeout, you need to call <code>join_session</code> to allocate a new consumer.</p><p>Each consumer is allocated a cache queue separately, and the pull order does not affect the content received by the consumer.</p><p>The request parameters require session ID and consumer ID:</p><div class="language-bash ext-sh line-numbers-mode"><pre class="language-bash"><code><span class="token function">curl</span> <span class="token parameter variable">-Ss</span> <span class="token parameter variable">-XPOST</span> http://localhost:8563/api <span class="token parameter variable">-d</span> <span class="token string">&#39;
{
  &quot;action&quot;:&quot;pull_results&quot;,
  &quot;sessionId&quot; : &quot;b09f1353-202c-407b-af24-701b744f971e&quot;,
  &quot;consumerId&quot; : &quot;8f7f6ad7bc2d4cb5aa57a530927a95cc_2&quot;
}
&#39;</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p>Use Bash scripts to regularly pull results messages:</p><div class="language-bash ext-sh line-numbers-mode"><pre class="language-bash"><code><span class="token keyword">while</span> <span class="token boolean">true</span><span class="token punctuation">;</span> <span class="token keyword">do</span> <span class="token function">curl</span> <span class="token parameter variable">-Ss</span> <span class="token parameter variable">-XPOST</span> http://localhost:8563/api <span class="token parameter variable">-d</span> <span class="token string">&#39;
{
  &quot;action&quot;:&quot;pull_results&quot;,
  &quot;sessionId&quot; : &quot;2b085b5d-883b-4914-ab35-b2c5c1d5aa2a&quot;,
  &quot;consumerId&quot; : &quot;8ecb9cb7c7804d5d92e258b23d5245cc_1&quot;
}
&#39;</span> <span class="token operator">|</span> json_pp<span class="token punctuation">;</span> <span class="token function">sleep</span> <span class="token number">2</span><span class="token punctuation">;</span> <span class="token keyword">done</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p>Note: The <code>json_pp</code> tool formats the output content as pretty json.</p><p>The response content is as follows:</p><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">{</span>
  <span class="token property">&quot;body&quot;</span><span class="token operator">:</span> <span class="token punctuation">{</span>
    <span class="token property">&quot;results&quot;</span><span class="token operator">:</span> <span class="token punctuation">[</span>
      <span class="token punctuation">{</span>
        <span class="token property">&quot;inputStatus&quot;</span><span class="token operator">:</span> <span class="token string">&quot;DISABLED&quot;</span><span class="token punctuation">,</span>
        <span class="token property">&quot;jobId&quot;</span><span class="token operator">:</span> <span class="token number">0</span><span class="token punctuation">,</span>
        <span class="token property">&quot;type&quot;</span><span class="token operator">:</span> <span class="token string">&quot;input_status&quot;</span>
      <span class="token punctuation">}</span><span class="token punctuation">,</span>
      <span class="token punctuation">{</span>
        <span class="token property">&quot;type&quot;</span><span class="token operator">:</span> <span class="token string">&quot;message&quot;</span><span class="token punctuation">,</span>
        <span class="token property">&quot;jobId&quot;</span><span class="token operator">:</span> <span class="token number">0</span><span class="token punctuation">,</span>
        <span class="token property">&quot;message&quot;</span><span class="token operator">:</span> <span class="token string">&quot;Welcome to arthas!&quot;</span>
      <span class="token punctuation">}</span><span class="token punctuation">,</span>
      <span class="token punctuation">{</span>
        <span class="token property">&quot;tutorials&quot;</span><span class="token operator">:</span> <span class="token string">&quot;https://arthas.aliyun.com/doc/arthas-tutorials.html&quot;</span><span class="token punctuation">,</span>
        <span class="token property">&quot;time&quot;</span><span class="token operator">:</span> <span class="token string">&quot;2020-08-06 15:56:43&quot;</span><span class="token punctuation">,</span>
        <span class="token property">&quot;type&quot;</span><span class="token operator">:</span> <span class="token string">&quot;welcome&quot;</span><span class="token punctuation">,</span>
        <span class="token property">&quot;jobId&quot;</span><span class="token operator">:</span> <span class="token number">0</span><span class="token punctuation">,</span>
        <span class="token property">&quot;pid&quot;</span><span class="token operator">:</span> <span class="token string">&quot;7909&quot;</span><span class="token punctuation">,</span>
        <span class="token property">&quot;wiki&quot;</span><span class="token operator">:</span> <span class="token string">&quot;https://arthas.aliyun.com/doc&quot;</span><span class="token punctuation">,</span>
        <span class="token property">&quot;version&quot;</span><span class="token operator">:</span> <span class="token string">&quot;3.3.7&quot;</span>
      <span class="token punctuation">}</span><span class="token punctuation">,</span>
      <span class="token punctuation">{</span>
        <span class="token property">&quot;inputStatus&quot;</span><span class="token operator">:</span> <span class="token string">&quot;ALLOW_INPUT&quot;</span><span class="token punctuation">,</span>
        <span class="token property">&quot;type&quot;</span><span class="token operator">:</span> <span class="token string">&quot;input_status&quot;</span><span class="token punctuation">,</span>
        <span class="token property">&quot;jobId&quot;</span><span class="token operator">:</span> <span class="token number">0</span>
      <span class="token punctuation">}</span>
    <span class="token punctuation">]</span>
  <span class="token punctuation">}</span><span class="token punctuation">,</span>
  <span class="token property">&quot;sessionId&quot;</span><span class="token operator">:</span> <span class="token string">&quot;b09f1353-202c-407b-af24-701b744f971e&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;consumerId&quot;</span><span class="token operator">:</span> <span class="token string">&quot;8f7f6ad7bc2d4cb5aa57a530927a95cc_2&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;state&quot;</span><span class="token operator">:</span> <span class="token string">&quot;SUCCEEDED&quot;</span>
<span class="token punctuation">}</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><h3 id="execute-commands-asynchronously" tabindex="-1"><a class="header-anchor" href="#execute-commands-asynchronously" aria-hidden="true">#</a> Execute commands asynchronously</h3><div class="language-bash ext-sh line-numbers-mode"><pre class="language-bash"><code><span class="token function">curl</span> <span class="token parameter variable">-Ss</span> <span class="token parameter variable">-XPOST</span> http://localhost:8563/api <span class="token parameter variable">-d</span> <span class="token string">&#39;&#39;</span>&#39;
<span class="token punctuation">{</span>
  <span class="token string">&quot;action&quot;</span><span class="token builtin class-name">:</span><span class="token string">&quot;async_exec&quot;</span>,
  <span class="token string">&quot;command&quot;</span><span class="token builtin class-name">:</span><span class="token string">&quot;watch demo.MathGame primeFactors <span class="token entity" title="\\&quot;">\\&quot;</span>{params, returnObj, throwExp}<span class="token entity" title="\\&quot;">\\&quot;</span> &quot;</span>,
  <span class="token string">&quot;sessionId&quot;</span> <span class="token builtin class-name">:</span> <span class="token string">&quot;2b085b5d-883b-4914-ab35-b2c5c1d5aa2a&quot;</span>
<span class="token punctuation">}</span>
<span class="token string">&#39;&#39;</span>&#39;
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p>Response of <code>async_exec</code>:</p><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">{</span>
  <span class="token property">&quot;sessionId&quot;</span><span class="token operator">:</span> <span class="token string">&quot;2b085b5d-883b-4914-ab35-b2c5c1d5aa2a&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;state&quot;</span><span class="token operator">:</span> <span class="token string">&quot;SCHEDULED&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;body&quot;</span><span class="token operator">:</span> <span class="token punctuation">{</span>
    <span class="token property">&quot;jobStatus&quot;</span><span class="token operator">:</span> <span class="token string">&quot;READY&quot;</span><span class="token punctuation">,</span>
    <span class="token property">&quot;jobId&quot;</span><span class="token operator">:</span> <span class="token number">3</span><span class="token punctuation">,</span>
    <span class="token property">&quot;command&quot;</span><span class="token operator">:</span> <span class="token string">&quot;watch demo.MathGame primeFactors \\&quot;{params, returnObj, throwExp}\\&quot; &quot;</span>
  <span class="token punctuation">}</span>
<span class="token punctuation">}</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><ul><li><code>state</code> : The status of <code>SCHEDULED</code> means that the command has been parsed and generated the job, but the execution has not started.</li><li><code>body.jobId</code> : The job id of command execution, filter the command results output in <code>pull_results</code> according to this job ID.</li><li><code>body.jobStatus</code> : The job status <code>READY</code> means that execution has not started.</li></ul><p>The shell output of the script that continuously pulls the result message:</p><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">{</span>
   <span class="token property">&quot;body&quot;</span> <span class="token operator">:</span> <span class="token punctuation">{</span>
      <span class="token property">&quot;results&quot;</span> <span class="token operator">:</span> <span class="token punctuation">[</span>
         <span class="token punctuation">{</span>
            <span class="token property">&quot;type&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;command&quot;</span><span class="token punctuation">,</span>
            <span class="token property">&quot;jobId&quot;</span> <span class="token operator">:</span> <span class="token number">3</span><span class="token punctuation">,</span>
            <span class="token property">&quot;state&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;SCHEDULED&quot;</span><span class="token punctuation">,</span>
            <span class="token property">&quot;command&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;watch demo.MathGame primeFactors \\&quot;{params, returnObj, throwExp}\\&quot; &quot;</span>
         <span class="token punctuation">}</span><span class="token punctuation">,</span>
         <span class="token punctuation">{</span>
            <span class="token property">&quot;inputStatus&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;ALLOW_INTERRUPT&quot;</span><span class="token punctuation">,</span>
            <span class="token property">&quot;jobId&quot;</span> <span class="token operator">:</span> <span class="token number">0</span><span class="token punctuation">,</span>
            <span class="token property">&quot;type&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;input_status&quot;</span>
         <span class="token punctuation">}</span><span class="token punctuation">,</span>
         <span class="token punctuation">{</span>
            <span class="token property">&quot;success&quot;</span> <span class="token operator">:</span> <span class="token boolean">true</span><span class="token punctuation">,</span>
            <span class="token property">&quot;jobId&quot;</span> <span class="token operator">:</span> <span class="token number">3</span><span class="token punctuation">,</span>
            <span class="token property">&quot;effect&quot;</span> <span class="token operator">:</span> <span class="token punctuation">{</span>
               <span class="token property">&quot;listenerId&quot;</span> <span class="token operator">:</span> <span class="token number">3</span><span class="token punctuation">,</span>
               <span class="token property">&quot;cost&quot;</span> <span class="token operator">:</span> <span class="token number">24</span><span class="token punctuation">,</span>
               <span class="token property">&quot;classCount&quot;</span> <span class="token operator">:</span> <span class="token number">1</span><span class="token punctuation">,</span>
               <span class="token property">&quot;methodCount&quot;</span> <span class="token operator">:</span> <span class="token number">1</span>
            <span class="token punctuation">}</span><span class="token punctuation">,</span>
            <span class="token property">&quot;type&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;enhancer&quot;</span>
         <span class="token punctuation">}</span><span class="token punctuation">,</span>
         <span class="token punctuation">{</span>
            <span class="token property">&quot;sizeLimit&quot;</span> <span class="token operator">:</span> <span class="token number">10485760</span><span class="token punctuation">,</span>
            <span class="token property">&quot;expand&quot;</span> <span class="token operator">:</span> <span class="token number">1</span><span class="token punctuation">,</span>
            <span class="token property">&quot;jobId&quot;</span> <span class="token operator">:</span> <span class="token number">3</span><span class="token punctuation">,</span>
            <span class="token property">&quot;type&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;watch&quot;</span><span class="token punctuation">,</span>
            <span class="token property">&quot;cost&quot;</span> <span class="token operator">:</span> <span class="token number">0.071499</span><span class="token punctuation">,</span>
            <span class="token property">&quot;ts&quot;</span> <span class="token operator">:</span> <span class="token number">1596703453237</span><span class="token punctuation">,</span>
            <span class="token property">&quot;value&quot;</span> <span class="token operator">:</span> <span class="token punctuation">[</span>
               <span class="token punctuation">[</span>
                  <span class="token number">-170365</span>
               <span class="token punctuation">]</span><span class="token punctuation">,</span>
               <span class="token null keyword">null</span><span class="token punctuation">,</span>
               <span class="token punctuation">{</span>
                  <span class="token property">&quot;stackTrace&quot;</span> <span class="token operator">:</span> <span class="token punctuation">[</span>
                     <span class="token punctuation">{</span>
                        <span class="token property">&quot;className&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;demo.MathGame&quot;</span><span class="token punctuation">,</span>
                        <span class="token property">&quot;classLoaderName&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;app&quot;</span><span class="token punctuation">,</span>
                        <span class="token property">&quot;methodName&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;primeFactors&quot;</span><span class="token punctuation">,</span>
                        <span class="token property">&quot;nativeMethod&quot;</span> <span class="token operator">:</span> <span class="token boolean">false</span><span class="token punctuation">,</span>
                        <span class="token property">&quot;lineNumber&quot;</span> <span class="token operator">:</span> <span class="token number">46</span><span class="token punctuation">,</span>
                        <span class="token property">&quot;fileName&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;MathGame.java&quot;</span>
                     <span class="token punctuation">}</span><span class="token punctuation">,</span>
                     ...
                  <span class="token punctuation">]</span><span class="token punctuation">,</span>
                  <span class="token property">&quot;localizedMessage&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;number is: -170365, need &gt;= 2&quot;</span><span class="token punctuation">,</span>
                  <span class="token property">&quot;@type&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;java.lang.IllegalArgumentException&quot;</span><span class="token punctuation">,</span>
                  <span class="token property">&quot;message&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;number is: -170365, need &gt;= 2&quot;</span>
               <span class="token punctuation">}</span>
            <span class="token punctuation">]</span>
         <span class="token punctuation">}</span><span class="token punctuation">,</span>
         <span class="token punctuation">{</span>
            <span class="token property">&quot;type&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;watch&quot;</span><span class="token punctuation">,</span>
            <span class="token property">&quot;cost&quot;</span> <span class="token operator">:</span> <span class="token number">0.033375</span><span class="token punctuation">,</span>
            <span class="token property">&quot;jobId&quot;</span> <span class="token operator">:</span> <span class="token number">3</span><span class="token punctuation">,</span>
            <span class="token property">&quot;ts&quot;</span> <span class="token operator">:</span> <span class="token number">1596703454241</span><span class="token punctuation">,</span>
            <span class="token property">&quot;value&quot;</span> <span class="token operator">:</span> <span class="token punctuation">[</span>
               <span class="token punctuation">[</span>
                  <span class="token number">1</span>
               <span class="token punctuation">]</span><span class="token punctuation">,</span>
               <span class="token punctuation">[</span>
                  <span class="token number">2</span><span class="token punctuation">,</span>
                  <span class="token number">2</span><span class="token punctuation">,</span>
                  <span class="token number">2</span><span class="token punctuation">,</span>
                  <span class="token number">2</span><span class="token punctuation">,</span>
                  <span class="token number">13</span><span class="token punctuation">,</span>
                  <span class="token number">491</span>
               <span class="token punctuation">]</span><span class="token punctuation">,</span>
               <span class="token null keyword">null</span>
            <span class="token punctuation">]</span><span class="token punctuation">,</span>
            <span class="token property">&quot;sizeLimit&quot;</span> <span class="token operator">:</span> <span class="token number">10485760</span><span class="token punctuation">,</span>
            <span class="token property">&quot;expand&quot;</span> <span class="token operator">:</span> <span class="token number">1</span>
         <span class="token punctuation">}</span>
      <span class="token punctuation">]</span>
   <span class="token punctuation">}</span><span class="token punctuation">,</span>
   <span class="token property">&quot;consumerId&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;8ecb9cb7c7804d5d92e258b23d5245cc_1&quot;</span><span class="token punctuation">,</span>
   <span class="token property">&quot;sessionId&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;2b085b5d-883b-4914-ab35-b2c5c1d5aa2a&quot;</span><span class="token punctuation">,</span>
   <span class="token property">&quot;state&quot;</span> <span class="token operator">:</span> <span class="token string">&quot;SUCCEEDED&quot;</span>
<span class="token punctuation">}</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p>The <code>value</code> of the watch command result is the value of watch-experss, and the above command is <code>{params, returnObj, throwExp}</code>, so the value of the watch result is an array of length 3, and each element corresponds to the expression in the corresponding order.</p><p>Please refer to the section &quot;<a href="#change_watch_value_to_map">Make watch command output a map object</a>&quot;.</p><h3 id="interrupt-command-execution" tabindex="-1"><a class="header-anchor" href="#interrupt-command-execution" aria-hidden="true">#</a> Interrupt command execution</h3><p>Interrupt the running foreground job of the session:</p><div class="language-bash ext-sh line-numbers-mode"><pre class="language-bash"><code><span class="token function">curl</span> <span class="token parameter variable">-Ss</span> <span class="token parameter variable">-XPOST</span> http://localhost:8563/api <span class="token parameter variable">-d</span> <span class="token string">&#39;&#39;</span>&#39;
<span class="token punctuation">{</span>
  <span class="token string">&quot;action&quot;</span><span class="token builtin class-name">:</span><span class="token string">&quot;interrupt_job&quot;</span>,
  <span class="token string">&quot;sessionId&quot;</span> <span class="token builtin class-name">:</span> <span class="token string">&quot;2b085b5d-883b-4914-ab35-b2c5c1d5aa2a&quot;</span>
<span class="token punctuation">}</span>
<span class="token string">&#39;&#39;</span>&#39;
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">{</span>
  <span class="token property">&quot;state&quot;</span><span class="token operator">:</span> <span class="token string">&quot;SUCCEEDED&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;body&quot;</span><span class="token operator">:</span> <span class="token punctuation">{</span>
    <span class="token property">&quot;jobStatus&quot;</span><span class="token operator">:</span> <span class="token string">&quot;TERMINATED&quot;</span><span class="token punctuation">,</span>
    <span class="token property">&quot;jobId&quot;</span><span class="token operator">:</span> <span class="token number">3</span>
  <span class="token punctuation">}</span>
<span class="token punctuation">}</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><h3 id="close-session" tabindex="-1"><a class="header-anchor" href="#close-session" aria-hidden="true">#</a> Close session</h3><p>Specify the session ID to close the session.</p><div class="language-bash ext-sh line-numbers-mode"><pre class="language-bash"><code><span class="token function">curl</span> <span class="token parameter variable">-Ss</span> <span class="token parameter variable">-XPOST</span> http://localhost:8563/api <span class="token parameter variable">-d</span> <span class="token string">&#39;&#39;</span>&#39;
<span class="token punctuation">{</span>
  <span class="token string">&quot;action&quot;</span><span class="token builtin class-name">:</span><span class="token string">&quot;close_session&quot;</span>,
  <span class="token string">&quot;sessionId&quot;</span> <span class="token builtin class-name">:</span> <span class="token string">&quot;2b085b5d-883b-4914-ab35-b2c5c1d5aa2a&quot;</span>
<span class="token punctuation">}</span>
<span class="token string">&#39;&#39;</span>&#39;
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">{</span>
  <span class="token property">&quot;state&quot;</span><span class="token operator">:</span> <span class="token string">&quot;SUCCEEDED&quot;</span>
<span class="token punctuation">}</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><h2 id="authentication" tabindex="-1"><a class="header-anchor" href="#authentication" aria-hidden="true">#</a> Authentication</h2>`,73),q=n("Reference: "),g=n("auth"),y=s("h2",{id:"web-ui",tabindex:"-1"},[s("a",{class:"header-anchor",href:"#web-ui","aria-hidden":"true"},"#"),n(" Web UI")],-1),f=s("p",null,[s("img",{src:i,alt:"",title:"arthas web ui"})],-1),x=n("A Web UI based on Http API, visit url : "),j={href:"http://127.0.0.1:8563/ui",target:"_blank",rel:"noopener noreferrer"},_=n("http://127.0.0.1:8563/ui"),I=n(" ."),w=t(`<p>Completed functions:</p><ul><li>Create a session</li><li>Copy and open the url to join the session, share the session with multiple people</li><li>Continuously pull session command result messages</li><li>Refresh the web page or join the session to pull command messages history</li><li>Control input or interrupt command status</li></ul><p>Pending function:</p><ul><li>Improve the readability of command result messages</li><li>Support automatic completion of input commands and command templates</li><li>Provide command help</li><li>Support personal profile settings</li></ul><p><a id="special_command_results"></a></p><h2 id="special-command-results" tabindex="-1"><a class="header-anchor" href="#special-command-results" aria-hidden="true">#</a> Special command results</h2><h3 id="status" tabindex="-1"><a class="header-anchor" href="#status" aria-hidden="true">#</a> status</h3><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">{</span>
  <span class="token property">&quot;jobId&quot;</span><span class="token operator">:</span> <span class="token number">5</span><span class="token punctuation">,</span>
  <span class="token property">&quot;statusCode&quot;</span><span class="token operator">:</span> <span class="token number">0</span><span class="token punctuation">,</span>
  <span class="token property">&quot;type&quot;</span><span class="token operator">:</span> <span class="token string">&quot;status&quot;</span>
<span class="token punctuation">}</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p><code>type</code> is <code>status</code> to indicate the command execution status:</p><p>After each command is executed, there is a unique status result. If the <code>statusCode</code> is 0, it means the execution is successful, and the <code>statusCode</code> is a non-zero value that means the execution failed, similar to the process exit code.</p><p>When the command execution fails, an error message is generally provided, such as:</p><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">{</span>
  <span class="token property">&quot;jobId&quot;</span><span class="token operator">:</span> <span class="token number">3</span><span class="token punctuation">,</span>
  <span class="token property">&quot;message&quot;</span><span class="token operator">:</span> <span class="token string">&quot;The argument &#39;class-pattern&#39; is required&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;statusCode&quot;</span><span class="token operator">:</span> <span class="token number">-10</span><span class="token punctuation">,</span>
  <span class="token property">&quot;type&quot;</span><span class="token operator">:</span> <span class="token string">&quot;status&quot;</span>
<span class="token punctuation">}</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><h3 id="input-status" tabindex="-1"><a class="header-anchor" href="#input-status" aria-hidden="true">#</a> input_status</h3><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">{</span>
  <span class="token property">&quot;inputStatus&quot;</span><span class="token operator">:</span> <span class="token string">&quot;ALLOW_INPUT&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;type&quot;</span><span class="token operator">:</span> <span class="token string">&quot;input_status&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;jobId&quot;</span><span class="token operator">:</span> <span class="token number">0</span>
<span class="token punctuation">}</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p><code>type</code> is <code>input_status</code> to indicate input status:</p><p>It is used to control user input during UI interaction, and a change message will be sent before and after each command is executed.</p><p>Possible values \u200B\u200Bof <code>inputStatus</code>:</p><ul><li><code>ALLOW_INPUT</code> : Allow users to enter commands, which means that the session has no foreground command being executed and can accept new command.</li><li><code>ALLOW_INTERRUPT</code> : Allow the user to interrupt the command execution, indicating that a command is currently being executed, and the user can send <code>interrupt_job</code> to interrupt the execution.</li><li><code>DISABLED</code> : In the disabled state, commands cannot be entered or interrupted.</li></ul><h3 id="command" tabindex="-1"><a class="header-anchor" href="#command" aria-hidden="true">#</a> command</h3><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">{</span>
  <span class="token property">&quot;type&quot;</span><span class="token operator">:</span> <span class="token string">&quot;command&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;jobId&quot;</span><span class="token operator">:</span> <span class="token number">3</span><span class="token punctuation">,</span>
  <span class="token property">&quot;state&quot;</span><span class="token operator">:</span> <span class="token string">&quot;SCHEDULED&quot;</span><span class="token punctuation">,</span>
  <span class="token property">&quot;command&quot;</span><span class="token operator">:</span> <span class="token string">&quot;watch demo.MathGame primeFactors \\&quot;{params, returnObj, throwExp}\\&quot; &quot;</span>
<span class="token punctuation">}</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p><code>type</code> is <code>command</code> to indicate the input command data:</p><p>It is used for the interactive UI to echo the commands entered by the user. The pulled session command message history will contain messages of type <code>command</code>, which can be processed in order.</p><h3 id="enhancer" tabindex="-1"><a class="header-anchor" href="#enhancer" aria-hidden="true">#</a> enhancer</h3><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">{</span>
  <span class="token property">&quot;success&quot;</span><span class="token operator">:</span> <span class="token boolean">true</span><span class="token punctuation">,</span>
  <span class="token property">&quot;jobId&quot;</span><span class="token operator">:</span> <span class="token number">3</span><span class="token punctuation">,</span>
  <span class="token property">&quot;effect&quot;</span><span class="token operator">:</span> <span class="token punctuation">{</span>
    <span class="token property">&quot;listenerId&quot;</span><span class="token operator">:</span> <span class="token number">3</span><span class="token punctuation">,</span>
    <span class="token property">&quot;cost&quot;</span><span class="token operator">:</span> <span class="token number">24</span><span class="token punctuation">,</span>
    <span class="token property">&quot;classCount&quot;</span><span class="token operator">:</span> <span class="token number">1</span><span class="token punctuation">,</span>
    <span class="token property">&quot;methodCount&quot;</span><span class="token operator">:</span> <span class="token number">1</span>
  <span class="token punctuation">}</span><span class="token punctuation">,</span>
  <span class="token property">&quot;type&quot;</span><span class="token operator">:</span> <span class="token string">&quot;enhancer&quot;</span>
<span class="token punctuation">}</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p><code>type</code> is <code>enhancer</code> to indicate the result of class enhancement:</p><p>Commands such as <code>trace/watch/jad/tt</code> need to enhance the class and will receive this <code>enhancer</code> result. It may happen that the result of <code>enhancer</code> is successful, but there is no hit method. The client can prompt the user according to the result of <code>enhancer</code>.</p><h2 id="cases" tabindex="-1"><a class="header-anchor" href="#cases" aria-hidden="true">#</a> Cases</h2><h3 id="get-classpath-of-java-application" tabindex="-1"><a class="header-anchor" href="#get-classpath-of-java-application" aria-hidden="true">#</a> Get classpath of Java application</h3><p>Get system properties of the Java application through Http api and extract the value of <code>java.class.path</code>.</p><div class="language-bash ext-sh line-numbers-mode"><pre class="language-bash"><code><span class="token assign-left variable">json_data</span><span class="token operator">=</span><span class="token variable"><span class="token variable">$(</span><span class="token function">curl</span> <span class="token parameter variable">-Ss</span> <span class="token parameter variable">-XPOST</span> http://localhost:8563/api <span class="token parameter variable">-d</span> <span class="token string">&#39;
{
  &quot;action&quot;:&quot;exec&quot;,
  &quot;command&quot;:&quot;sysprop&quot;
}&#39;</span><span class="token variable">)</span></span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><ul><li>Extract value with <code>sed</code>:</li></ul><div class="language-bash ext-sh line-numbers-mode"><pre class="language-bash"><code><span class="token assign-left variable">class_path</span><span class="token operator">=</span><span class="token variable"><span class="token variable">$(</span><span class="token builtin class-name">echo</span> $json_data <span class="token operator">|</span> <span class="token function">tr</span> <span class="token parameter variable">-d</span> <span class="token string">&#39;\\n&#39;</span> <span class="token operator">|</span> <span class="token function">sed</span> <span class="token string">&#39;s/.*&quot;java.class.path&quot;:&quot;\\([^&quot;]*\\).*/\\1/&#39;</span><span class="token variable">)</span></span>
<span class="token builtin class-name">echo</span> <span class="token string">&quot;classpath: <span class="token variable">$class_path</span>&quot;</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div></div></div><ul><li>Extract value with <code>json_pp/awk</code>:</li></ul><div class="language-bash ext-sh line-numbers-mode"><pre class="language-bash"><code><span class="token assign-left variable">class_path</span><span class="token operator">=</span><span class="token variable"><span class="token variable">$(</span><span class="token builtin class-name">echo</span> $json_data <span class="token operator">|</span> <span class="token function">tr</span> <span class="token parameter variable">-d</span> <span class="token string">&#39;\\n&#39;</span> <span class="token operator">|</span> json_pp <span class="token operator">|</span> <span class="token function">grep</span> java.class.path <span class="token operator">|</span> <span class="token function">awk</span> -F<span class="token string">&#39;&quot;&#39;</span> <span class="token string">&#39;{ print $4 }&#39;</span><span class="token variable">)</span></span>
<span class="token builtin class-name">echo</span> <span class="token string">&quot;classpath: <span class="token variable">$class_path</span>&quot;</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div></div></div><p>Output:</p><div class="language-text ext-text line-numbers-mode"><pre class="language-text"><code>classpath: demo-arthas-spring-boot.jar
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div></div></div><p>NOTE:</p><ul><li><code>echo $json_data | tr -d &#39;\\n&#39;</code> : Delete line breaks (the value of <code>line.separator</code>) to avoid affecting the processing of <code>sed</code>/<code>json_pp</code> commands.</li><li><code>awk -F&#39;&quot;&#39; &#39;{ print $4 }&#39;</code> : Use double quote as delimiter</li></ul><p><a id="change_watch_value_to_map"></a></p><h3 id="make-watch-command-output-a-map-object" tabindex="-1"><a class="header-anchor" href="#make-watch-command-output-a-map-object" aria-hidden="true">#</a> Make watch command output a map object</h3>`,40),E=n("The result value of "),T=s("code",null,"watch",-1),S=n(" is generated by calculating the "),C=s("code",null,"watch-express",-1),D=n(" ognl expression. You can change the ognl expression to generate the desired value, please refer to "),A={href:"https://commons.apache.org/proper/commons-ognl/language-guide.html",target:"_blank",rel:"noopener noreferrer"},O=n("OGNL document"),P=n("."),L=t(`<div class="custom-container tip"><p class="custom-container-title">TIP</p><p>Maps can also be created using a special syntax.</p><p>#{ &quot;foo&quot; : &quot;foo value&quot;, &quot;bar&quot; : &quot;bar value&quot; }</p><p>This creates a Map initialized with mappings for &quot;foo&quot; and &quot;bar&quot;.</p></div><p>The following command generates values \u200B\u200Bin map format:</p><div class="language-bash ext-sh line-numbers-mode"><pre class="language-bash"><code><span class="token function">watch</span> *MathGame prime* <span class="token string">&#39;#{ &quot;params&quot; : params, &quot;returnObj&quot; : returnObj, &quot;throwExp&quot;: throwExp}&#39;</span> <span class="token parameter variable">-x</span> <span class="token number">2</span> <span class="token parameter variable">-n</span> <span class="token number">5</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div></div></div><p>Execute the above command in Telnet shell/WebConsole, the output result:</p><div class="language-bash ext-sh line-numbers-mode"><pre class="language-bash"><code><span class="token assign-left variable">ts</span><span class="token operator">=</span><span class="token number">2020</span>-08-06 <span class="token number">16</span>:57:20<span class="token punctuation">;</span> <span class="token punctuation">[</span>cost<span class="token operator">=</span><span class="token number">0</span>.241735ms<span class="token punctuation">]</span> <span class="token assign-left variable">result</span><span class="token operator">=</span>@LinkedHashMap<span class="token punctuation">[</span>
    @String<span class="token punctuation">[</span>params<span class="token punctuation">]</span>:@Object<span class="token punctuation">[</span><span class="token punctuation">]</span><span class="token punctuation">[</span>
        @Integer<span class="token punctuation">[</span><span class="token number">1</span><span class="token punctuation">]</span>,
    <span class="token punctuation">]</span>,
    @String<span class="token punctuation">[</span>returnObj<span class="token punctuation">]</span>:@ArrayList<span class="token punctuation">[</span>
        @Integer<span class="token punctuation">[</span><span class="token number">2</span><span class="token punctuation">]</span>,
        @Integer<span class="token punctuation">[</span><span class="token number">241</span><span class="token punctuation">]</span>,
        @Integer<span class="token punctuation">[</span><span class="token number">379</span><span class="token punctuation">]</span>,
    <span class="token punctuation">]</span>,
    @String<span class="token punctuation">[</span>throwExp<span class="token punctuation">]</span>:null,
<span class="token punctuation">]</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p>Execute the above command with Http api, pay attention to escaping the JSON double quotes:</p><div class="language-bash ext-sh line-numbers-mode"><pre class="language-bash"><code><span class="token function">curl</span> <span class="token parameter variable">-Ss</span> <span class="token parameter variable">-XPOST</span> http://localhost:8563/api <span class="token parameter variable">-d</span> @- <span class="token operator">&lt;&lt;</span> <span class="token string">EOF
{
  &quot;action&quot;:&quot;exec&quot;,
  &quot;execTimeout&quot;: 30000,
  &quot;command&quot;:&quot;watch *MathGame prime* &#39;#{ <span class="token entity" title="\\&quot;">\\&quot;</span>params<span class="token entity" title="\\&quot;">\\&quot;</span> : params, <span class="token entity" title="\\&quot;">\\&quot;</span>returnObj<span class="token entity" title="\\&quot;">\\&quot;</span> : returnObj, <span class="token entity" title="\\&quot;">\\&quot;</span>throwExp<span class="token entity" title="\\&quot;">\\&quot;</span>: throwExp}&#39; -n 3 &quot;
}
EOF</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p>Http api execution result:</p><div class="language-json ext-json line-numbers-mode"><pre class="language-json"><code><span class="token punctuation">{</span>
    <span class="token property">&quot;body&quot;</span><span class="token operator">:</span> <span class="token punctuation">{</span>
         ...
        <span class="token property">&quot;results&quot;</span><span class="token operator">:</span> <span class="token punctuation">[</span>
            ...
            <span class="token punctuation">{</span>
                ...
                <span class="token property">&quot;type&quot;</span><span class="token operator">:</span> <span class="token string">&quot;watch&quot;</span><span class="token punctuation">,</span>
                <span class="token property">&quot;value&quot;</span><span class="token operator">:</span> <span class="token punctuation">{</span>
                    <span class="token property">&quot;params&quot;</span><span class="token operator">:</span> <span class="token punctuation">[</span>
                        <span class="token number">1</span>
                    <span class="token punctuation">]</span><span class="token punctuation">,</span>
                    <span class="token property">&quot;returnObj&quot;</span><span class="token operator">:</span> <span class="token punctuation">[</span>
                        <span class="token number">2</span><span class="token punctuation">,</span>
                        <span class="token number">5</span><span class="token punctuation">,</span>
                        <span class="token number">17</span><span class="token punctuation">,</span>
                        <span class="token number">23</span><span class="token punctuation">,</span>
                        <span class="token number">23</span>
                    <span class="token punctuation">]</span>
                <span class="token punctuation">}</span>
            <span class="token punctuation">}</span><span class="token punctuation">,</span>
            <span class="token punctuation">{</span>
                ...
                <span class="token property">&quot;type&quot;</span><span class="token operator">:</span> <span class="token string">&quot;watch&quot;</span><span class="token punctuation">,</span>
                <span class="token property">&quot;value&quot;</span><span class="token operator">:</span> <span class="token punctuation">{</span>
                    <span class="token property">&quot;params&quot;</span><span class="token operator">:</span> <span class="token punctuation">[</span>
                        <span class="token number">-98278</span>
                    <span class="token punctuation">]</span><span class="token punctuation">,</span>
                    <span class="token property">&quot;throwExp&quot;</span><span class="token operator">:</span> <span class="token punctuation">{</span>
                        <span class="token property">&quot;@type&quot;</span><span class="token operator">:</span> <span class="token string">&quot;java.lang.IllegalArgumentException&quot;</span><span class="token punctuation">,</span>
                        <span class="token property">&quot;localizedMessage&quot;</span><span class="token operator">:</span> <span class="token string">&quot;number is: -98278, need &gt;= 2&quot;</span><span class="token punctuation">,</span>
                        <span class="token property">&quot;message&quot;</span><span class="token operator">:</span> <span class="token string">&quot;number is: -98278, need &gt;= 2&quot;</span><span class="token punctuation">,</span>
                        <span class="token property">&quot;stackTrace&quot;</span><span class="token operator">:</span> <span class="token punctuation">[</span>
                            ...
                        <span class="token punctuation">]</span>
                    <span class="token punctuation">}</span>
                <span class="token punctuation">}</span>
            <span class="token punctuation">}</span><span class="token punctuation">,</span>
            ...
<span class="token punctuation">}</span>
</code></pre><div class="line-numbers" aria-hidden="true"><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div><div class="line-number"></div></div></div><p>You can see that the value of the watch result becomes a map object, and the program can read value through a key .</p>`,10);function U(R,N){const e=o("ExternalLinkIcon"),p=o("RouterLink");return l(),u("div",null,[m,s("p",null,[s("a",v,[k,b,a(e)])]),h,s("ul",null,[s("li",null,[q,a(p,{to:"/en/doc/auth.html"},{default:r(()=>[g]),_:1})])]),y,f,s("p",null,[x,s("a",j,[_,a(e)]),I]),w,s("p",null,[E,T,S,C,D,s("a",A,[O,a(e)]),P]),L])}const W=c(d,[["render",U],["__file","http-api.html.vue"]]);export{W as default};
